Program Osszes_Sorrend_Program;
(*
  Feladat: összes lehetséges sorrend.
*)
  Const
    MaxN=10;
    MaxDb=10000000;
  Type
    TPermutacio=Array [1..MaxN] of Integer;
    TPermutaciok=Array [1..MaxDb] of TPermutacio;
  Var
    N:Integer;
    Db:Integer;
    Y:TPermutaciok;

  Procedure Beolvasas(Var N:Integer);
  Begin
    //A felhasználónak szánt tájékoztató üzenetek az StrErr csatotnára írandók!
    //Például a kérdések:
    Write(StdErr,'N (1..',MaxN,'):');
    //A bemenetet nem ellenőrizzük sem szintaktikai, sem szemantikai szempontból.
    Readln(N);//1<=N<=MaxN
  End;

  Function Volt(Const i,j:Integer; Const X:TPermutacio):Boolean;
    Var
      k:Integer;
  Begin
    k:=1;
    While (k<i) and (X[k]<>j) do
    Begin
      Inc(k);//ugyanaz, mint k:=k+1
    End;
    Volt:=k<i;
  End;
  
  Procedure Osszes_sorrend(Const i:Integer; Const N:Integer; 
                           Var Db:Integer; Var Y:TPermutaciok; Var x:TPermutacio);
    Var
      j:Integer;
  Begin
    If i>N then
    Begin
      Inc(Db);//ugyanaz, mint Db:=Db+1
      Y[Db]:=x;
    End
      else
    Begin
      For j:=1 to N do
      Begin
        If not Volt(i,j,x) then
        Begin
          x[i]:=j;
          Osszes_sorrend(i+1,N,Db,Y,x);
        End;
      End;
    End;
  End;

  Procedure Megoldas(Const N:Integer; Var Db:Integer; Var Y:TPermutaciok);
    Var
      x:TPermutacio;
  Begin
    Db:=0;
    Osszes_sorrend(1,N,Db,Y,x);
  End;

  Procedure Kiiras(Const N:Integer; Const Db:Integer; Const Y:TPermutaciok);
    Var
      i,j:Integer;
  Begin
    //A kimenetet kísérő szövegek is az StdErr-re irandók!
    Write(StdErr,'A sorozat '); 
    For i:=1 to Db do
    Begin
      Write(StdErr,i:4,'.: ');
	  For j:=1 to N do
      Begin
        Write(Y[i,j],' ');
      End;
      Writeln;
    End;
  End;
  
Begin
  Beolvasas(N);
  Megoldas(N,Db,Y);
  Kiiras(N,Db,Y);
End.
