Program Szoosszeado_Program;
(*
  Feladat: Szóösszeadó fejtörő.
*)
  Const
    MaxN=8;
    MaxDb=100000;
  Type
    TPermutacio=Array [1..MaxN] of Integer;
    TPermutaciok=Array [1..MaxDb] of TPermutacio;
  Var
    Db:Integer;
    Y:TPermutaciok;

  Function Volt(Const i,j:Integer; Const X:TPermutacio):Boolean;
    Var
      k:Integer;
  Begin
    k:=1;
    While (k<i) and (X[k]<>j) do
    Begin
      Inc(k);//ugyanaz, mint k:=k+1
    End;
    Volt:=k<i;
  End;
  
  Function Jo(Const x:TPermutacio):Boolean;
  Begin
    Jo:=(x[1]*1000+x[2]*91+x[3]*(-90)+x[4]*1+x[5]*(-9000)+
         x[6]*(-900)+x[7]*10+x[8]*(-1)=0) and 
        (x[1]<>0) and (x[5]<>0);
  End;
  
  Procedure Osszes_sorrend(Const i:Integer; Const N:Integer; 
                           Var Db:Integer; Var Y:TPermutaciok; Var x:TPermutacio);
    Var
      j,jj:Integer;
  Begin
    If i=N+1 then
    Begin
      If Jo(x) then
      Begin
        Inc(Db);//ugyanaz, mint Db:=Db+1
        Y[Db]:=x;
      End
    End
      else//i<=N
    Begin
      If (i=1) or (i=5) then jj:=1 else jj:=0;
      For j:=jj to 9 do
      Begin
        If not Volt(i,j,x) then
        Begin
          x[i]:=j;
          Osszes_sorrend(i+1,N,Db,Y,x);
        End;
      End;
    End;
  End;

  Procedure Megoldas(Var Db:Integer; Var Y:TPermutaciok);
    Var
      x:TPermutacio;
  Begin
    Db:=0;
    Osszes_sorrend(1,8,Db,Y,x);
  End;

  Procedure Kiiras(Const Y:TPermutaciok);
    Const
      szoveg:String='SENDMORY';
      N=8;
    Var
      i,j:Integer;
  Begin
    For i:=1 to Db do
    Begin
      Writeln(StdErr,i,'. megoldas:');
      For j:=1 to N do
	  Begin
        Writeln(szoveg[j],' ',Y[i,j]);
      End;
    End;
  End;
  
Begin
  Megoldas(Db,Y);
  Kiiras(Y);
End.
